package com.AndroidC.ForHappyDate;

import java.util.List;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.res.Resources;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.os.Handler;
import android.view.Display;
import android.view.View;
import android.view.WindowManager;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class FMap extends MapActivity {
	 private MapView mv;
	    private List<Address> addrs;
	    private Handler handler = new Handler();
	    private MapController mapController;
	    private String str;
	    private GeoPoint point;
	    private ProgressDialog pd;
	    private Double lat;
	    private Double lng;
	    private List< Overlay > overlays;
	    private String desc;
	    
	    /*
	     *  Ŀ  Ŭ
	     * 
	     */
	    private class MapViewItemizedOverlay extends ItemizedOverlay< OverlayItem > {
	    	private Drawable marker;
	    	private OverlayItem oi;
	    	private String desc; // Ŀ Ŭ Ÿ 
	    	
	    	public MapViewItemizedOverlay( Drawable marker, String desc ) {
	    		super( marker );
	    		this.marker = marker;
	    		this.desc = desc;
	    		populate();
	    	}
	    	
	    	@Override
	    	protected OverlayItem createItem( int index ) {
	    			OverlayItem oi = new OverlayItem( point, "Ŀ", desc );
	    			this.oi = oi;
	    			return oi;
	  
	    	}
	    	@Override
	    	public void draw(Canvas canvas, MapView mapView, boolean shadow) {
	    		super.draw(canvas, mapView, shadow);
	    		boundCenterBottom( marker );
	 
	   
	    	}

	    	@Override
	    	protected boolean onTap(int i) {
	    		Toast.makeText(FMap.this, desc, Toast.LENGTH_SHORT).show();

	    		return true;
	    	}

	    	@Override
	    	public int size() {
	    		return 1;
	    	}
	    }
	    
	    @Override
	    public void onCreate(Bundle savedInstanceState) {
	    	super.onCreate(savedInstanceState);
	        setContentView(R.layout.fmaps);
	        
	        // ʺ ߰ 
	        final MapView mv = ( MapView ) findViewById( R.id.mapView );
	        mv.setStreetView(true);
		    mv.setTraffic(true);
		    
		    
		    // Ȯ/ Ʈѷ ʿ  Ű
		    Display display = (( WindowManager ) getSystemService( Context.WINDOW_SERVICE )).getDefaultDisplay();
		    int width = display.getWidth();
		    int height = display.getHeight();
		    
		    final MapView.LayoutParams lp = new MapView.LayoutParams( MapView.LayoutParams.WRAP_CONTENT,
			        								MapView.LayoutParams.WRAP_CONTENT, 
			        								width/2,
			        								height-100, 
			        								MapView.LayoutParams.CENTER);
		   
		     View zoom = mv.getZoomControls();
		     mv.addView( zoom, lp );
		     mv.displayZoomControls(true);
		     
		     //  Ȯؼ  Ƽ ̵
			 mapController = mv.getController();
			 mapController.setZoom(18);
			 


			 // ּҿ ̸
			
			 str = getIntent().getExtras().getString("desAddr");
			 desc = getIntent().getExtras().getString("subject");
		
			 overlays = mv.getOverlays();
			 overlays.clear();
		    
			 // ּҸ ҷ ȯ  
			 new Thread( null, geo, "geocoder" ).start();
			 mv.postInvalidate();
	    }

		@Override
		protected boolean isRouteDisplayed() {
			// TODO Auto-generated method stub
			return true;
		}
		
		private Runnable geo = new Runnable() {
			public void run() {
				try {
					// ùٸ ּҷ ȯ
					str = stringMatch( str );
					Geocoder mGeoCoder = new Geocoder(getApplicationContext(), Locale.KOREA);
					addrs = mGeoCoder.getFromLocationName( str, 1);
					if( addrs.size() == 0 ) {
						
					}

					// /浵 ϱ
					lat = addrs.get(0).getLatitude()*1E6;
					lng = addrs.get(0).getLongitude()*1E6;
				
					point = new GeoPoint( lat.intValue(), lng.intValue() );
					mapController.setCenter(point);
					 mapController.animateTo( point );
					 
					 // Ŀ ̹ ߰
					 Resources r = getResources(); 
					 Drawable d = r.getDrawable( R.drawable.here );	

					 // Ŀ ߰
				     MapViewItemizedOverlay marker = new MapViewItemizedOverlay( d, desc );
				     overlays.add( marker );
				     
				} catch( Exception e ) {}
			}
		};
		
		/*
		 * 긮 긮   ΰ  ùٸ ʴ ּҸ ùٸ ּҷ ȯϴ Լ
		 */
		private String stringMatch( String place ) {
			Pattern p = Pattern.compile( "([-R]*)" );
			Matcher m = p.matcher( place );
			String replace = null;
			while( m.find() ) {
				replace = m.group();
			}
			
			if( replace != null ) return place.replaceFirst( replace, " " );
			
			return place;
		}
}
